package eu.eiting.StarCharge.control;

/**
 * Simple class to measure if a certain amount of time has passed.
 * 
 * @author Caspar Eiting
 *
 */
public class Timer {
	// OBJECT ATTRIBUTES
	//====================================
	private long startTime		= 0;
	private final long duration;
	//====================================
	
	// CONSTRUCTOR
	//====================================
	public Timer(float duration){
		this.duration = (int)(duration * 1000);
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	public void start(){
		startTime = System.currentTimeMillis();
	}
	
	public boolean isDone(){
		if(System.currentTimeMillis() - startTime > duration){
			return true;
		} else {
			return false;
		}
	}
	//====================================
	
	// GETTER AND SETTER
	//====================================
	public long getRemainingTime(){
		return Math.max((System.currentTimeMillis() + duration) - startTime, 0);
	}
	//====================================
}
