package eu.eiting.StarCharge.control.controller;

import java.awt.event.KeyListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.model.GameModel;
import eu.eiting.StarCharge.model.Updateable;
import eu.eiting.StarCharge.model.listener.ChangeListener;

/**
 * Base class for the different controllers that are used in the different states of the game.
 * 
 * @author Caspar Eiting
 *
 */
public abstract class BaseController implements Updateable, KeyListener, MouseListener, MouseMotionListener, ChangeListener<GameModel> {
	// OBJECT ATTRIBUTES
	// ====================================
	private GameModel gameModel = null;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public BaseController(){
		StarCharge.addGameModelListener(this);
	}
	// ====================================
	
	// OBJECT METHODS
	// ====================================
	@Override
	public void onChange(GameModel model) {
		gameModel = model;
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	protected GameModel getGameModel(){
		return gameModel;
	}
	// ====================================
}
