package eu.eiting.StarCharge.control.controller;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import eu.eiting.StarCharge.visualization.menu.container.GUIContainer;

/**
 * The controller that manages the input while in the main menu.
 * 
 * @author Caspar Eiting
 *
 */
public class MenuController extends BaseController {
	// OBJECT ATTRIBUTES
	// ============================================
	// reference that is used to pass the events to the the GUIElements 
	private GUIContainer container = null;
	// ============================================
	
	// CONSTRCUTOR
	// ============================================
	public MenuController(GUIContainer container){
		this.container = container;
	}
	// ============================================

	// OBJECT METHODS
	// ============================================
	@Override
	public void mouseDragged(MouseEvent e) {
		container.currentMenu.onMouseMotion(e);
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		if (container.currentMenu.isActive()) {
			container.currentMenu.onMouseMotion(e);
		}
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {}

	@Override
	public void mouseExited(MouseEvent e) {}

	@Override
	public void mousePressed(MouseEvent e) {
		if (container.currentMenu.isActive()) {
			container.currentMenu.onMousePress(e);
		}
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		if (container.currentMenu.isActive()) {
			container.currentMenu.onMouseRelease(e);
		}
	}

	@Override
	public void keyPressed(KeyEvent e) {}

	@Override
	public void keyReleased(KeyEvent e) {}

	@Override
	public void keyTyped(KeyEvent e) {}
	
	@Override
	public void update() {}
	// ============================================
}
