package eu.eiting.StarCharge.control.controller;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import eu.eiting.StarCharge.visualization.menu.SolarSystemGUI;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer;

/**
 * Controller that manages the input while the player is moving her fleet through the solar system.
 *
 * @author Caspar Eiting
 *
 */
public class SolarSystemController extends BaseController {
	// OBJECT ATTRIBUTES
	// ============================================
	private GUIContainer gui				= null;
	private SolarSystemGUI solarSystemHUD	= null;
	// ============================================
	
	// CONTRUCTOR
	// ============================================
	public SolarSystemController(GUIContainer gui, SolarSystemGUI solarSystemHUD){
		this.gui			= gui;
		this.solarSystemHUD = solarSystemHUD;
	}
	// ============================================
	
	// OBJECT METHODS
	// ============================================
	@Override
	public void update() {
		gui.currentMenu.update();
	}
	
	@Override
	public void keyTyped(KeyEvent e) {}

	@Override
	public void keyPressed(KeyEvent e) {}

	@Override
	public void keyReleased(KeyEvent e) {}

	@Override
	public void mouseClicked(MouseEvent e) {}

	@Override
	public void mousePressed(MouseEvent e) {
		gui.currentMenu.onMousePress(e);
		solarSystemHUD.onMousePress(e);
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		gui.currentMenu.onMouseRelease(e);
		solarSystemHUD.onMouseRelease(e);
	}

	@Override
	public void mouseEntered(MouseEvent e) {}

	@Override
	public void mouseExited(MouseEvent e) {}

	@Override
	public void mouseDragged(MouseEvent e) {}

	@Override
	public void mouseMoved(MouseEvent e) {
		gui.currentMenu.onMouseMotion(e);
		solarSystemHUD.onMouseMotion(e);
	}
	// ============================================
}
