package eu.eiting.StarCharge.control.states;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.model.GameModel;
import eu.eiting.StarCharge.model.listener.ChangeListener;

/**
 * The base class for each state of the game.
 * 
 * @author Caspar Eiting
 *
 */
public abstract class BaseState implements ChangeListener<GameModel> {
	// ENUM
	// ============================================
	// the possible states
	public enum States{MENU_STATE, GAME_STATE, PAUSE_STATE, SOLAR_SYSTEM_STATE}
	// ============================================
	
	// OBJECT ATTRIBUTES
	// ============================================
	private GameModel gameModel = null;
	// ============================================
	
	// CONSTRUCTOR
	// ============================================
	public BaseState(){
		StarCharge.addGameModelListener(this);
	}
	// ============================================
	
	// OBJECT METHODS
	// ============================================
	public abstract void enter();
	
	public abstract void execute();
	
	public abstract void exit();
	
	@Override
	public void onChange(GameModel obj) {
		gameModel = obj;
	}
	// ============================================
	
	// GETTER AND SETTER
	// ============================================
	protected GameModel getGameModel(){
		return gameModel;
	}
	// ============================================
}
