package eu.eiting.StarCharge.control.states;

import java.util.List;

import eu.eiting.StarCharge.model.BattleField;
import eu.eiting.StarCharge.model.objects.Projectile;
import eu.eiting.StarCharge.model.solarSystem.Fleet;

/**
 * The state that manages the game while fighting in a battle.
 * 
 * @author Caspar Eiting
 *
 */
public class GameState extends BaseState {
	// CONSTRUCTOR
	// ====================================
	public GameState() {}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public void enter() {
	}

	@Override
	public void execute() {
		if (getGameModel() != null) {
			BattleField battlefield = getGameModel().getBattleField();

			if (battlefield != null) {

				Fleet aggressor = battlefield.getAggressor();
				
				for (int i = 0; i < aggressor.getStarShipCount(); i++) {
					aggressor.getStarShip(i).update();
				}

				Fleet defender = battlefield.getDefender();

				for (int i = 0; i < defender.getStarShipCount(); i++) {
					defender.getStarShip(i).update();
				}

				List<Projectile> projectiles = battlefield.getProjectiles();

				for (int i = 0; i < projectiles.size(); i++) {
					projectiles.get(i).update();
				}
			}
		}
	}

	@Override
	public void exit() {
	}
	// ====================================
}
