package eu.eiting.StarCharge.control.states;

import eu.eiting.StarCharge.model.AIPlayer;

/**
 * The state that manages the game while the player is traveling the solar system.
 * 
 * @author Caspar Eiting
 *
 */
public class SolarSystemState extends BaseState {
	// CONSTRUCTOR
	// ============================================
	public SolarSystemState() {
	}
	// ============================================

	// OBJECT METHODS
	// ============================================
	@Override
	public void enter() {
	}

	@Override
	public void execute() {
		if (getGameModel() != null) {
			getGameModel().solarSystem.update();

			getGameModel().player.update();

			for (AIPlayer player : getGameModel().players) {
				player.update();
			}
		}
	}

	@Override
	public void exit() {
	}
	// ============================================
}
