package eu.eiting.StarCharge.model;

import java.util.ArrayList;

import eu.eiting.StarCharge.model.objects.starship.StarShip;
import eu.eiting.StarCharge.model.solarSystem.Fleet;
import eu.eiting.StarCharge.model.structure.Vector2;

public class AIPlayer extends Player {
	// CLASS ATTRIBUTES
	// ============================================
	private static final long serialVersionUID = -7818347804704938963L;
	// ============================================
	
	// OBJECT ATTRIBUTES
	// ============================================
	private final ArrayList<Fleet> fleets = new ArrayList<>();
	// ============================================

	// CONSTRUCTOR
	// ============================================
	public AIPlayer(String name){
		super(name);
		
		// TODO: remove
		Fleet current = new Fleet(new Vector2(64, 64), "Example Fleet", "fleet");
		
		current.addShip(new StarShip(new Vector2(-128, -256), 5, "OBJECT_asteroidSmall_01"));
		current.addShip(new StarShip(new Vector2(512, -128), 5, "OBJECT_asteroidSmall_01"));
		current.addShip(new StarShip(new Vector2(0, -512), 5, "OBJECT_asteroidSmall_01"));
		
		addFleet(current);
		
	}
	// ============================================
	
	// OBJECT METHODS
	// ============================================
	private boolean fleetExists(int index) {
		if (index >= 0 && index < fleets.size()) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public void update() {
		for (Fleet fleet : fleets) {
			fleet.update();
		}
	}
	// ============================================
	
	// GETTER AND SETTER
	// ============================================
	public Fleet getFleet(int index) {

		return fleets.get(index);
	}

	public int getFleetCount() {
		return fleets.size();
	}
	
	public void addFleet(Fleet fleet) {
		this.fleets.add(fleet);

		GameModel.raiseOnFleetAdditionEvent(fleet);
	}

	public void removeFleet(int index) {
		if (fleetExists(index)) {
			GameModel.raiseOnFleetRemovalEvent(fleets.get(index));

			fleets.remove(index);
		}
	}
	
	public boolean containsFleet(int index) {
		if (index >= 0 && index < fleets.size()) {
			return true;
		} else {
			return false;
		}
	}
	// ============================================
}
