package eu.eiting.StarCharge.model;

import eu.eiting.StarCharge.model.objects.starship.StarShip;
import eu.eiting.StarCharge.model.solarSystem.Fleet;
import eu.eiting.StarCharge.model.structure.Vector2;

public class HumanPlayer extends Player {
	// CLASS ATTRIBUTES
	// ============================================
	private static final long serialVersionUID = 687607524890936177L;
	// ============================================
	
	// OBJECT ATTRIBUTES
	// ============================================
	private StarShip playerShip		= null;
	private final Fleet playerFleet = new Fleet(Vector2.ZERO, "unnamed Battlefleet", "fleet");
	// ============================================
	
	// CONSTRUCTOR
	// ============================================
	public HumanPlayer(){
		super("unnamed");
	}
	// ============================================
	
	// OBJECT METHODS
	// ============================================
	@Override
	public void update() {
		playerFleet.update();
	}
	// ============================================
	
	// GETTER AND SETTER
	// ============================================
	public StarShip getStarShip(){
		return playerShip;
	}
	
	public void setStarShip(StarShip ship){
		playerShip = ship;
	
		playerFleet.clearShips();
			
		playerFleet.addShip(playerShip);
	}
	
	public Fleet getFleet(){
		return playerFleet;
	}
	
	@Override
	public void setName(String name) {
		super.setName(name);
		
		playerFleet.setName( name + "'s Battlefleet");
	}
	// ============================================
}
