package eu.eiting.StarCharge.model.objects;

import java.awt.image.BufferedImage;
import java.io.IOException;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.model.Drawable;
import eu.eiting.StarCharge.model.GameModel;
import eu.eiting.StarCharge.model.resources.Textures;
import eu.eiting.StarCharge.model.resources.datatypes.ImageCircle;
import eu.eiting.StarCharge.model.structure.Vector2;

public class Projectile extends MotionObject implements Drawable {
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID = 874962000656643966L;
	//====================================
	
	// OBJECT ATTRIBUTES
	//====================================
	private Vector2 origin					= null;
	private double range					= 0;
	private String apperanceId				= null;
	private transient ImageCircle images;
	//====================================
	
	// CONSTRUCTOR
	//====================================
	public Projectile(Vector2 position, Vector2 direction, Vector2 velocity, double range, String id){
		this.apperanceId	= id;
		this.range 			= range;
		this.origin			= position;
		this.velocity		= velocity;
		this.images			= Textures.getResource(ImageCircle.class, apperanceId);
		
		this.getTransform().setPosition(position);
		this.getTransform().setDirection(direction);
		
		GameModel.addProjectile(this);
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	@Override
	public void update() {
		getTransform().setPosition(Vector2.add(getTransform().getPosition(), velocity));

		if(Vector2.distance(origin, getTransform().getPosition()) > range){
			GameModel.removeProjectile(this);
		}
		
		// TODO: Remove ... this is a stupid and unfinished way to check collision 
		for (int index = 0; index < StarCharge.getCurrentBattlefield().getDefender().getStarShipCount(); index++) {
			if(Vector2.distance(getTransform().getPosition(), StarCharge.getCurrentBattlefield().getDefender().getStarShip(index).getTransform().getPosition()) < 16){
				GameModel.removeProjectile(this);
			}
		}
	}
	
	@Override
	public BufferedImage getImage() {
		return images.getImage(getTransform().getRotation()).getSource();
	}
	
	private void writeObject(java.io.ObjectOutputStream out) throws IOException{
		out.defaultWriteObject();
	}
	
	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException{
		 in.defaultReadObject();
		 
		 this.images = Textures.getResource(ImageCircle.class, apperanceId);
	}
	//====================================
}
