package eu.eiting.StarCharge.model.objects.starship.slots;

import java.awt.image.BufferedImage;

import eu.eiting.StarCharge.model.Drawable;
import eu.eiting.StarCharge.model.Updateable;
import eu.eiting.StarCharge.model.objects.GameObject;
import eu.eiting.StarCharge.model.objects.starship.systems.subSystem.SubSystem;

/**
 * represents a slot of the space ship in which sub system can be installed.
 * 
 *  - each ship has a certain amount of subsystem slots
 *  - subsystem slots can contain subsystems like drone controller ...
 *  
 * @author Caspar Eiting
 *
 */
public class SubSystemSlot extends GameObject implements Updateable, Drawable{
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID = 4999700146947691724L;
	//====================================
	
	// OBJECT ATTRIBUTES
	//====================================
	public SubSystem installedSystem = null;
	//====================================
	
	// OBJECT METHODS
	//====================================
	public void installSubSystem(SubSystem newSystem) {
		installedSystem = newSystem;
		
		installedSystem.install();
	}
	
	public void deinstallSubSystem(){
		installedSystem.remove();
		
		installedSystem = null;
	}

	@Override
	public void update() {}

	@Override
	public BufferedImage getImage() {
		return null;
	}
	//====================================
}
