package eu.eiting.StarCharge.model.objects.starship.systems.coreSystem;

import eu.eiting.StarCharge.model.Drawable;
import eu.eiting.StarCharge.model.objects.starship.systems.ShipSystem;
import eu.eiting.StarCharge.model.structure.Vector2;

/**
 * Base class for the core system that are installed in each space ship.
 * 
 *  - core systems have levels and a position
 *  
 * @author Caspar Eiting
 *
 */
public abstract class CoreSystem extends ShipSystem implements Drawable{
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID 	= -352308069044060567L;
	public static final int MIN_LEVEL			= 0;
	public static final int MAX_LEVEL			= 5;
	//====================================
	
	// OBJECT ATTRIBUTES
	//====================================
	protected int level							= 0;
	protected Vector2 position					= null;
	//====================================
	
	// CONSTRUCTOR
	//====================================
	public CoreSystem(Vector2 position){
		this.position = position;
	}
	
	public CoreSystem(int x, int y){
		this(new Vector2(x, y));
	}
	//====================================
	
	// GETTER AND SETTER
	//====================================
	public abstract void setLevel(int level);
	
	public int getLevel(){
		return level;
	}
	//====================================
}
