package eu.eiting.StarCharge.model.objects.starship.systems.coreSystem;

import java.awt.image.BufferedImage;
import eu.eiting.StarCharge.model.structure.Vector2;

public class Engine extends CoreSystem {
	// CLASS ATTRIBUTES
	// ====================================
	private static final long serialVersionUID	= 7571862002006068512L;
	public static final int FOWARD_DIRECTION_01	= 0;
	public static final int FOWARD_DIRECTION_02	= 1;
	public static final int RIGHT_DIRECTION		= 2;
	public static final int BACKWARD_DIRECTION_01	= 3;
	public static final int BACKWARD_DIRECTION_02	= 4;
	public static final int LEFT_DIRECTION		= 5;
	// ====================================
	
	// OBJECT ATTRIBUTES
	// ====================================
	public final Thruster[] THRUSTERS;
	private float basePower						= 0.0f;
	public float power							= 0.0f;
	// ====================================

	// CONSTRCUTOR
	// ====================================
	public Engine(Vector2 position, int level, float basePower) {
		super(position);
		this.basePower = basePower;
		
		// TODO: remove and load from xml
		THRUSTERS 							= new Thruster[6];
		THRUSTERS[FOWARD_DIRECTION_01]		= new Thruster(new Vector2(32.0f, 70.0f), 0.0f, 0.5f);
		THRUSTERS[FOWARD_DIRECTION_02]		= new Thruster(new Vector2(47.0f, 70.0f), 0.0f, 0.5f);
		THRUSTERS[RIGHT_DIRECTION]			= new Thruster(new Vector2(48.0f, 32.0f), 270.0f, 0.25f);
		THRUSTERS[BACKWARD_DIRECTION_01]	= new Thruster(new Vector2(23.0f, 46.0f), 180.0f, 0.125f);
		THRUSTERS[BACKWARD_DIRECTION_02]	= new Thruster(new Vector2(56.0f, 46.0f), 180.0f, 0.125f);
		THRUSTERS[LEFT_DIRECTION]			= new Thruster(new Vector2(32.0f, 32.0f), 90.0f, 0.25f);

		setLevel(level);
	}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public void update() {}
	
	public void forward(boolean value){
		THRUSTERS[FOWARD_DIRECTION_01].isActivate(value);
		THRUSTERS[FOWARD_DIRECTION_02].isActivate(value);
	}

	public void backward(boolean value){
		THRUSTERS[BACKWARD_DIRECTION_01].isActivate(value);
		THRUSTERS[BACKWARD_DIRECTION_02].isActivate(value);
	}
	
	public void right(boolean value){
		THRUSTERS[RIGHT_DIRECTION].isActivate(value);
	}
	
	public void left(boolean value){
		THRUSTERS[LEFT_DIRECTION].isActivate(value);
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	public Vector2 getAcceleration(Vector2 shipDirection){
		Vector2 acceleration = Vector2.ZERO;

		for (int currentThruster = 0; currentThruster < THRUSTERS.length; currentThruster++) {
			if (THRUSTERS[currentThruster].getActive()) {
				acceleration = Vector2.add(acceleration, THRUSTERS[currentThruster].getAcceleration(shipDirection));
			}
		}

		if (acceleration.magnitude > power) {
			acceleration = new Vector2(acceleration, power);
		}

		return acceleration;
	}

	@Override
	public void setLevel(int level) {
		if (level < CoreSystem.MIN_LEVEL) {
			this.level = CoreSystem.MIN_LEVEL;
		} else if(level > CoreSystem.MAX_LEVEL){
			this.level = CoreSystem.MAX_LEVEL;
		} else {
			this.level = level;
		}

		power = basePower * level;
	}

	@Override
	public BufferedImage getImage() {
		
		return null;
	}
	// ====================================
}
