package eu.eiting.StarCharge.model.objects.starship.systems.coreSystem;

import java.awt.image.BufferedImage;

import eu.eiting.StarCharge.model.structure.Vector2;

public class Hull extends CoreSystem {
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID = 6785188776874378547L;
	//====================================
	
	// OBJECT ATTRIBUTES
	//====================================
	protected int armor					= 0;
	protected float currentHullStrength	= 0.0f;
	protected float maximalHullStrength	= 0.0f;
	protected float baseHullStrength	= 0.0f;
	protected int baseArmor				= 0;
	//====================================
	
	// CONSTRCUTOR
	//====================================
	public Hull(Vector2 position, int level, float baseHullStrength, int baseArmor) {
		super(position);
		this.baseHullStrength	= baseHullStrength;
		this.baseArmor			= baseArmor;
		
		setLevel(level);

		this.currentHullStrength = maximalHullStrength;
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	@Override
	public void update() {}
	//====================================
	
	// GETTER AND SETTER
	//====================================
	@Override
	public void setLevel(int level){
		if (level < CoreSystem.MIN_LEVEL) {
			this.level 		= CoreSystem.MIN_LEVEL;
		} else if(level > CoreSystem.MAX_LEVEL){
			this.level 		= CoreSystem.MAX_LEVEL;
		} else {
			this.level 		= level;
		}
		
		// calculate maximalPower and rechargeRate
		//====================================
		maximalHullStrength = baseHullStrength * level;
		armor				= baseArmor * level;
		//====================================
	}

	public int getArmor() {
		return armor;
	}

	public void setArmor(int armor) {
		this.armor = armor;
	}

	public float getCurrentHullStrength() {
		return currentHullStrength;
	}

	public void setCurrentHullStrength(float currentHullStrength) {
		if(currentHullStrength > maximalHullStrength) {
			this.currentHullStrength = maximalHullStrength;
		} else {
			this.currentHullStrength = currentHullStrength;
		}
	}

	public float getMaximalHullStrength() {
		return maximalHullStrength;
	}

	public void setMaximalHullStrength(float maximalHullStrength) {
		this.maximalHullStrength = maximalHullStrength;
	}
	
	public float getPowerFactor(){
		return currentHullStrength / maximalHullStrength;
	}
	
	@Override
	public BufferedImage getImage() {
		return null;
	}
	//====================================
}
