package eu.eiting.StarCharge.model.objects.starship.systems.coreSystem;

import java.awt.image.BufferedImage;

import eu.eiting.StarCharge.model.structure.Vector2;

public class Shield extends CoreSystem {
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID = 5856714383166339028L;
	//====================================
	
	// OBJECT ATTRIBUTES
	//====================================
	protected float currentPower		= 0.0f;
	protected float maximalPower		= 0.0f;
	protected float rechargeRate		= 0.0f;
	protected float basePower			= 0.0f;
	protected float baseRechargeRate	= 0.0f;
	//====================================

	// CONSTRUCTOR
	//====================================
	public Shield(Vector2 position, int level, float basePower, float baseRechargeRate){
		super(position);
		this.basePower			= basePower;
		this.baseRechargeRate	= baseRechargeRate;

		setLevel(level);
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	@Override
	public void update() {
		setCurrentPower(currentPower + rechargeRate);
	}
	//====================================
	
	// GETTER AND SETTER
	//====================================
	public float getCurrentPower(){
		return currentPower;
	}
	
	public void setCurrentPower(float power){
		if (power > maximalPower) {
			this.currentPower = maximalPower;
		} else {
			this.currentPower = power;
		}
	}
	
	public void setLevel(int level){
		if (level < CoreSystem.MIN_LEVEL) {
			this.level = CoreSystem.MIN_LEVEL;
		} else if(level > CoreSystem.MAX_LEVEL){
			this.level = CoreSystem.MAX_LEVEL;
		} else {
			this.level = level;
		}
		
		// calculate maximalPower and rechargeRate
		//====================================
		maximalPower = basePower * level;
		rechargeRate = baseRechargeRate * level;
		//====================================
	}
	
	public float getMaximalPower(){
		return maximalPower;
	}
	
	public void setMaximalPower(float power){
		this.maximalPower = power;
	}
	
	public float getRechargeRate(){
		return rechargeRate;
	}
	
	public void setRechargeRate(float rechargeRate){
		this.rechargeRate = rechargeRate;
	}
	
	public float getPowerFactor(){
		return currentPower / maximalPower;
	}
	
	@Override
	public BufferedImage getImage() {
		return null;
	}
	//====================================
}
