package eu.eiting.StarCharge.model.objects.starship.systems.weaponSystem;

import eu.eiting.StarCharge.model.Drawable;
import eu.eiting.StarCharge.model.objects.starship.StarShip;
import eu.eiting.StarCharge.model.objects.starship.slots.WeaponSlot;
import eu.eiting.StarCharge.model.objects.starship.systems.ShipSystem;

/**
 * The abstract base for all ShipWeapons in the game.
 * 
 * @author The Singularity
 *
 */
public abstract class BaseWeapon extends ShipSystem implements Drawable{
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID = -3486833421983952441L;
	//====================================
	
	// OBEJECT ATTRIBUTES
	//====================================
	private final String TYPE;
	private final StarShip SHIP;
	private final WeaponSlot SLOT;
	//====================================
	
	// CONSTRUCTOR
	//====================================
	public BaseWeapon(String type, StarShip ship, WeaponSlot slot){
		this.TYPE = type;
		this.SHIP = ship;
		this.SLOT = slot;
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	public abstract void fire();
	//====================================
	
	// GETTER AND SETTER
	//====================================
	public String getType(){
		return TYPE;
	}
	
	protected StarShip getShip() {
		return SHIP;
	}
	
	protected WeaponSlot getSlot() {
		return SLOT;
	}
	//====================================
}
