package eu.eiting.StarCharge.model.objects.starship.systems.weaponSystem;

import java.awt.image.BufferedImage;

import eu.eiting.StarCharge.model.objects.Projectile;
import eu.eiting.StarCharge.model.objects.starship.StarShip;
import eu.eiting.StarCharge.model.objects.starship.slots.WeaponSlot;
import eu.eiting.StarCharge.model.structure.Vector2;

public class Pulsorbeam extends BaseWeapon {
	// CLASS ATTRIBUTES
	//====================================
	private static final long serialVersionUID = 654022710205787810L;
	//====================================
	
	// OBJECT ATTRIBUTES
	//====================================
	private int fireRate			= 5;
	private int coolDown			= 0;
	private double range			= 900;
	private float projectileSpeed	= 15;
	//====================================
	
	// CONSTRUCTOR
	//====================================
	public Pulsorbeam(StarShip ship, WeaponSlot slot){
		super("pulsorBeam", ship, slot);
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	@Override
	public void fire() {
		if(coolDown == 0){
			Vector2 initialVelocity = new Vector2(getShip().getTransform().getDirection(), projectileSpeed);
			
			new Projectile(getSlot().getTransform().getPosition(), getSlot().getTransform().getDirection(), Vector2.add(initialVelocity, getShip().getVelocity()), range, "pulsorBeam");

			coolDown = fireRate;
		}
	}

	@Override
	public void update() {
		if(coolDown > 0){
			coolDown--;
		}
	}
	//====================================

	// GETTER AND SETTER
	//====================================
	@Override
	public BufferedImage getImage() {
		return null;
	}
	//====================================
}
