package eu.eiting.StarCharge.model.profiles;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;

/**
 * Class that manages saving and loading of profiles.
 * 
 * @author Caspar Eiting
 *
 */
public class ProfileUtility {
	// CLASS ATTRIBUTES
	// ============================================
	private static List<Profile> profiles	= null;
	private static Profile current			= null;
	// ============================================
	
	// CLASS METHODS
	// ============================================
	public static void addProfile(Profile profile){
		profiles.add(profile);
	}

	public static void removeProfile(int index){
		profiles.remove(index);
	}
	
	public static List<Profile> getProfiles(){
		if (profiles == null) {
			ProfileUtility.loadProfiles();
			
			return profiles;
		} else {
			return profiles;
		}
	}

	@SuppressWarnings("unchecked")
	public static void loadProfiles() {
		ObjectInputStream objInStream = null;
		
		try {
			objInStream = new ObjectInputStream(new FileInputStream("profiles.prof"));
			
			Object loadedObject = objInStream.readObject();
			
			if(loadedObject instanceof ArrayList){
				profiles = (ArrayList<Profile>) loadedObject;
			} else {
				profiles = new  ArrayList<Profile>();
			}
		} catch (FileNotFoundException e) {
			profiles = new  ArrayList<Profile>();
		} catch (IOException e) {
			profiles = new  ArrayList<Profile>();
		} catch (ClassNotFoundException e) {
			profiles = new  ArrayList<Profile>();
		} finally {
			if(objInStream != null){
				try {
					objInStream.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	public static void saveProfiles() {
		ObjectOutputStream objOutStream = null;

		try {
			objOutStream = new ObjectOutputStream(new FileOutputStream("profiles.prof"));
			
			objOutStream.writeObject(profiles);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				objOutStream.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public static void setActiveProfil(Profile profil) {
		current = profil;
	}
	
	public static Profile getActiveProfil(){
		return current;
	}
	// ============================================
}
