package eu.eiting.StarCharge.model.resources.datatypes;

import java.util.ArrayList;
import java.util.List;

public class ImageCircle {
	// CLASS ATTRIBUTES
	// ============================================
	private static final BufferedImageProxy MISSING_RESSOURCE = new BufferedImageProxy();
	// ============================================
	
	// OBJECT ATTRIBUTES
	// ============================================
	private final List<BufferedImageProxy> IMAGES;
	private final double FACTOR;
	// ============================================
	
	// CONSTRUCTORS
	// ============================================
	public ImageCircle(){
		this.IMAGES = new ArrayList<>();
		this.FACTOR = 1.0;
	}
	
	public ImageCircle(List<BufferedImageProxy> IMAGES, int steps){
		this.IMAGES = IMAGES;
		this.FACTOR = 360.0 / steps;
	}
	// ============================================
	
	// GETTER AND SETTER
	// ============================================
	public BufferedImageProxy getImage(double degree){
		degree = Math.abs(degree);
		
		if(degree >= 360){
			degree %= 360;
		}
		
		if(IMAGES.size() != 0){
			return IMAGES.get((int)(degree / FACTOR));
		} else {
			System.out.println("WARNING: DEGREE[" + degree +"] could not be retrived from ImageCircle, because it wasn't loaded properply");
			
			return MISSING_RESSOURCE;
		}
	}
	// ============================================
}
