package eu.eiting.StarCharge.model.resources.infos;

import java.util.ArrayList;
import java.util.List;

import eu.eiting.StarCharge.model.resources.datatypes.ImageCircle;
import eu.eiting.StarCharge.model.resources.datatypes.BufferedImageProxy;
import eu.eiting.StarCharge.model.resources.loader.ImageCircleLoader;

public class ImageCircleInfo implements ResourceInfo{
	// OBJECT ATTRIBUTES
	// ====================================
	private final String ID;
	private final String FILE;
	private final int STEPS;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public ImageCircleInfo(String ID, String FILE, int STEPS){
		this.ID		= ID;
		this.FILE	= FILE;
		this.STEPS	= STEPS;
	}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public ImageCircle loadRessource() {
		
		List<BufferedImageProxy> images = new ArrayList<>();
		
		for (int index = 0; index < STEPS; index++) {
			images.add(new BufferedImageProxy());
		}
		
		ImageCircleLoader loader = new ImageCircleLoader(FILE, images);
		
		loader.start();

		ImageCircle resource = new ImageCircle(images, STEPS);
		
		return resource;
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	@Override
	public String getID() {
		return ID;
	}
	// ====================================
}
