package eu.eiting.StarCharge.model.resources.infos;

import java.util.ArrayList;
import java.util.List;

import eu.eiting.StarCharge.model.resources.datatypes.BufferedImageProxy;
import eu.eiting.StarCharge.model.resources.datatypes.ImageList;
import eu.eiting.StarCharge.model.resources.loader.ImageListLoader;

public class ImageListInfo implements ResourceInfo {
	// OBJECT ATTRIBUTES
	// ====================================
	private final String ID;
	private final List<String> FILES; 
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public ImageListInfo(String ID, ArrayList<String> FILES){
		this.ID		= ID;
		this.FILES	= FILES;
	}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public ImageList loadRessource() {
		
		List<BufferedImageProxy> images = new ArrayList<>();
		
		for (int index = 0; index < FILES.size(); index++) {
			images.add(new BufferedImageProxy());
		}
		
		ImageList resource = new ImageList(images);
		
		ImageListLoader loader = new ImageListLoader(FILES, images);
		
		loader.start();
		
		return resource;
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	@Override
	public String getID() {
		return ID;
	}
	// ====================================
}
