package eu.eiting.StarCharge.model.resources.loader;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.util.List;

import eu.eiting.StarCharge.model.resources.ImageTool;
import eu.eiting.StarCharge.model.resources.datatypes.BufferedImageProxy;

public class ImageCircleLoader extends Thread {
	private final String FILE;
	private final List<BufferedImageProxy> IMAGES;

	public ImageCircleLoader(String FILE, List<BufferedImageProxy> IMAGES) {
		this.FILE	= FILE;
		this.IMAGES	= IMAGES;
	}

	@Override
	public void run() {
		BufferedImage source = ImageTool.load(FILE);
		
		double degreePerStep = 360 / IMAGES.size();
		
		// create a BufferedImage for each step of the array based on the length and assign it to the ProxyImage in the array
		for (int index = 0; index < IMAGES.size(); index++) {	
			BufferedImage nextImage = new BufferedImage((int) (source.getWidth() * 1.5), (int) (source.getHeight() * 1.5), BufferedImage.TYPE_INT_ARGB);
	
			Graphics2D g2d = (Graphics2D) nextImage.getGraphics();
	
			double radian = Math.toRadians(degreePerStep * index);
	
			g2d.rotate(radian, (int) (nextImage.getWidth() / 2), (int) (nextImage.getHeight() / 2));
	
			g2d.drawImage(source, source.getWidth() / 4, source.getHeight() / 4, null);
	
			IMAGES.get(index).setSource(nextImage);
		}
	}
}
