package eu.eiting.StarCharge.visualization.menu;

import java.awt.event.MouseEvent;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.model.GameModel;
import eu.eiting.StarCharge.model.Updateable;
import eu.eiting.StarCharge.model.listener.ChangeListener;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer;
import eu.eiting.StarCharge.visualization.menu.menuElements.GUIElement;

public abstract class BaseGUI implements Updateable, ChangeListener<GameModel> {
	// OBJECT ATTRIBUTES
	//====================================
	private final GUIContainer PARENT;
	private GameModel gameModel			= null;
	private boolean isActive			= true;
	//====================================
	
	// CONSTRUCTOR
	//====================================
	public BaseGUI(GUIContainer parent){
		this.PARENT = parent;
		
		StarCharge.addGameModelListener(this);
	}
	//====================================
	
	// OBJECT METHODS
	//====================================
	public abstract GUIElement[] getElements();

	public abstract void onMousePress(MouseEvent event);

	public abstract void onMouseRelease(MouseEvent event);
	
	public abstract void onMouseMotion(MouseEvent event);
	
	@Override
	public void onChange(GameModel gameModel) {
		this.gameModel = gameModel;
	}
	//====================================
	
	// GETTER AND SETTER
	//====================================
	public boolean isActive(){
		return isActive;
	}
	
	public void setActive(boolean state){
		this.isActive = state;
	}
	
	protected GameModel getGameModel(){
		return gameModel;
	}
	
	protected GUIContainer getParent() {
		return PARENT;
	}
	//====================================
}
