package eu.eiting.StarCharge.visualization.menu;

import java.awt.Rectangle;
import java.awt.event.MouseEvent;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.model.profiles.Profile;
import eu.eiting.StarCharge.model.profiles.ProfileUtility;
import eu.eiting.StarCharge.visualization.GameFrame;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer.Menus;
import eu.eiting.StarCharge.visualization.menu.menuElements.GUIElement;
import eu.eiting.StarCharge.visualization.menu.menuElements.ScreenKeyboardElement;
import eu.eiting.StarCharge.visualization.menu.menuElements.TextElement;

public class ProfileAddMenuGUI extends BaseGUI {
	// OBJECT ATTRIBUTES
	// ====================================
	private final ScreenKeyboardElement KEYBOARD_ELEMENT;
	private final TextElement TEXT_ELEMENT;
	private final GUIElement[] ELEMENTS;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public ProfileAddMenuGUI(GUIContainer container) {
		super(container);

		TEXT_ELEMENT	= new TextElement(new Rectangle((int)((GameFrame.getResolution().getWidth() - 512) / 2), 256, 512, 64));
		KEYBOARD_ELEMENT = new ScreenKeyboardElement((int)((GameFrame.getResolution().getWidth() - 680) / 2), 384);

		ELEMENTS		= new GUIElement[2];
		ELEMENTS[0]		= KEYBOARD_ELEMENT;
		ELEMENTS[1]		= TEXT_ELEMENT;
	}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public void update() {}

	@Override
	public void onMousePress(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMousePress(event);
		}

		TEXT_ELEMENT.setContent(KEYBOARD_ELEMENT.getInput().toString());
		
		if (KEYBOARD_ELEMENT.getValue() == ScreenKeyboardElement.DONE) {
			Profile profil = new Profile(KEYBOARD_ELEMENT.getInput().toString());
			
			StarCharge.startGame();
			
			ProfileUtility.addProfile(profil);
			
			ProfileUtility.setActiveProfil(profil);

			KEYBOARD_ELEMENT.clearInput();
			TEXT_ELEMENT.clearContent();
			
			getParent().changeMenu(Menus.MAIN_MENU);
		}
	}

	@Override
	public void onMouseRelease(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMouseRelease(event);
		}
	}

	@Override
	public void onMouseMotion(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMouseMotion(event);
		}
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	@Override
	public GUIElement[] getElements() {
		return ELEMENTS;
	}
	// ====================================
}
