package eu.eiting.StarCharge.visualization.menu;

import java.awt.event.MouseEvent;
import java.util.List;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.model.profiles.Profile;
import eu.eiting.StarCharge.model.profiles.ProfileUtility;
import eu.eiting.StarCharge.visualization.GameFrame;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer;
import eu.eiting.StarCharge.visualization.menu.menuElements.GUIElement;
import eu.eiting.StarCharge.visualization.menu.menuElements.list.ListElement;

public class ProfileMainMenuGUI extends BaseGUI {
	// OBJECT ATTRIBUTES
	// ====================================
	private final ListElement PROFILE_ELEMENT;
	private final GUIElement[] ELEMENTS		= new GUIElement[1];
	private List<Profile> profiles			= null;
	private int state						= 0;
	// ====================================

	// CONSTRUCTOR
	// ====================================
	public ProfileMainMenuGUI(GUIContainer container) {
		super(container);
		
		profiles		= ProfileUtility.getProfiles();
		PROFILE_ELEMENT = new ListElement((int) ((GameFrame.getResolution().getWidth() - 256) / 2), 64);
		ELEMENTS[0]		= PROFILE_ELEMENT;
		
		state = profiles.size();
		
		setupProfiles();
	}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public void onMousePress(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMousePress(event);
		}
		
		if(PROFILE_ELEMENT.getValue() == ListElement.OK_BUTTON){
			StarCharge.loadGame(profiles.get(PROFILE_ELEMENT.getSelected().getIndex()).getFileName());
			
			getParent().changeMenu(GUIContainer.Menus.MAIN_MENU);
		}
		
		if(PROFILE_ELEMENT.getValue() == ListElement.ADD_BUTTON){
			getParent().changeMenu(GUIContainer.Menus.PROFILE_ADD_MENU);
		}
		
		if(PROFILE_ELEMENT.getValue() == ListElement.DELETE_BUTTON){
			ProfileUtility.removeProfile(PROFILE_ELEMENT.getSelected().getIndex());
			
			setupProfiles();
		}
	}

	@Override
	public void onMouseRelease(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMouseRelease(event);
		}
	}

	@Override
	public void onMouseMotion(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMouseMotion(event);
		}
	}

	private void setupProfiles(){
		String[] listElements = new String[profiles.size()];

		for (int i = 0; i < listElements.length; i++) {
			listElements[i] = profiles.get(i).getName(); 
		}
				
		PROFILE_ELEMENT.setElements(listElements);
	}
	
	@Override
	public void update() {
		if(state != profiles.size()){
			setupProfiles();
		}
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	@Override
	public GUIElement[] getElements() {
		return ELEMENTS;
	}
	// ====================================
}
