package eu.eiting.StarCharge.visualization.menu.container;

import java.util.HashMap;

import eu.eiting.StarCharge.visualization.menu.BaseGUI;
import eu.eiting.StarCharge.visualization.menu.menuElements.GUIElement;

/**
 * A container for menus that manages the visibility and usability of the menus
 * 
 * @author Caspar Eiting
 * 
 */
public class GUIContainer {
	// ENUM
	//====================================
	public enum Menus{PROFILE_MAIN_MENU, PROFILE_ADD_MENU, MAIN_MENU, GAME_MENU, GAME_HUD, SOLAR_SYSTEM_HUD};
	//====================================
	
	// OBJECT ATTRIBUTES
	// ====================================
	public BaseGUI currentMenu				= null;
	private HashMap<Menus, BaseGUI> menus	= null;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public GUIContainer(){
		menus = new HashMap<Menus, BaseGUI>();
	}
	// ====================================
	
	// OBJECT METHODS
	// ====================================	
	public void addMenu(Menus key, BaseGUI menu){
		menus.put(key, menu);
		
		if (currentMenu == null) {
			currentMenu = menu;
		}
	}
	
	public boolean changeMenu(Menus key){
		BaseGUI nextMenu = menus.get(key);
		
		if(nextMenu != null){
			currentMenu = nextMenu;
			
			currentMenu.update();
			
			return true;
		} else {
			return false;
		}
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	public GUIElement[] getGuiElements(){
		if(currentMenu != null){
			return currentMenu.getElements();
		} else {
			return null;
		}
	}
	// ====================================
}
