package eu.eiting.StarCharge.visualization.menu.menuElements;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;

import eu.eiting.StarCharge.visualization.utility.Color2D;


public class BarElement extends GUIElement {
	// OBJECT ATTRIBUTES
	// ============================================
	private float primaryLevel		= 0;
	private float maxLevel			= 100.0f;
	private float secondaryLevel	= 0.0f;
	private Color primary			= null;
	private Color secondary 		= null;
	private Color text				= null;
	private boolean isActive		= false;
	private BufferedImage product	= null;
	// ============================================

	// CONSTRUCTOR
	// ============================================
	public BarElement(Rectangle dimension, Color primary, Color secondary, Color text) {
		super(dimension);

		this.primary	= primary;
		this.secondary	= secondary;
		this.text		= text;
		this.product	= new BufferedImage(dimension.width, dimension.height, BufferedImage.TYPE_INT_ARGB);
	}
	
	@Override
	public void onMousePress(MouseEvent event) {}
	
	@Override
	public void onMouseRelease(MouseEvent event) {}
	
	@Override
	public void onMouseMotion(MouseEvent event) {
		if(getDimension().contains(event.getPoint())){
			isActive = true;
		} else {
			isActive = false;
		}
	}
	// ============================================

	// GETTER AND SETTER
	// ============================================
	@Override
	public BufferedImage getImage() {
		float primaryFactor		= primaryLevel / maxLevel;
		float secondaryFactor	= secondaryLevel / maxLevel;

		Color2D.empty(product);
		
		Graphics g = product.getGraphics();
		
		// PRIMARY BAR
		// ============================================
		g.setColor(primary);
		g.fillRect(0, 0, (int) (getDimension().width * primaryFactor ), getDimension().height);
		// ============================================
		
		// SECONDARY BAR
		// ============================================
		g.setColor(secondary);
		g.fillRect((int) (getDimension().width * primaryFactor), 0, (int) (getDimension().width * secondaryFactor), getDimension().height);
		// ============================================
		
		// TEXT
		// ============================================
		g.setColor(text);

		if (isActive == true) {
			g.drawString(primaryLevel + "/" + maxLevel, 8, 10);
		} else {
			g.drawString((int) (primaryFactor * 100) + " %", 8, 10);
		}
		// ============================================
		
		return product;
	}
	
	public void setPrimaryLevel(float primaryLevel){
		this.primaryLevel = primaryLevel;
	}
	
	public float getPrimaryLevel(){
		return primaryLevel;
	}
	
	public void setMaxLevel(float maxlevel){
		this.maxLevel = maxlevel;
	}
	
	public float getMaxLevel(){
		return maxLevel;
	}
	
	public void setSecondaryLevel(float secondaryLevel){
		this.secondaryLevel = secondaryLevel;
	}
	
	public float getSecondaryLevel(){
		return secondaryLevel;
	}
	
	public void setPrimaryColor(Color primary){
		this.primary = primary;
	}
	
	public Color getPrimaryColor(){
		return primary;
	}
	
	public void setSecondaryColor(Color secondary){
		this.secondary = secondary;
	}
	
	public Color getSecondaryColor(){
		return secondary;
	}

	public void setActive(boolean value) {
		this.isActive = value;
	}

	public boolean isActive() {
		return isActive;
	}
	// ============================================
}
