package eu.eiting.StarCharge.visualization.menu.menuElements;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;

import eu.eiting.StarCharge.model.resources.Textures;
import eu.eiting.StarCharge.model.resources.datatypes.BufferedImageProxy;
import eu.eiting.StarCharge.model.resources.datatypes.ImageList;
import eu.eiting.StarCharge.visualization.utility.ImageProcessing;

public class ScreenKeyboardElement extends GUIElement{
	// CLASS ATTRIBUTES
	// ====================================
	public static final int DONE		= 0;
	public static final int NOT_DONE	= 1;
	// ====================================
	
	// OBJECT ATTRIBUTES
	// ====================================
	private final ButtonElement[] ELEMENTS			= new ButtonElement[26];
	private final ButtonElement SPACE_BUTTON;
	private final ButtonElement RETURN_BUTTON;
	private final ButtonElement BACKSPACE_BUTTON;
	private StringBuilder input						= new StringBuilder();
	private int value								= NOT_DONE;
	private final BufferedImageProxy IMAGE;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public ScreenKeyboardElement(int x, int y){
		super(new Rectangle(x, y, 256, 256));
		
		ImageList images = null;
		
		// BACKGROUND
		// ====================================
		IMAGE = Textures.getResource(BufferedImageProxy.class, "screenkeyboard_background");
		// ====================================
		
		// FIRST ROW
		// ====================================
		images = Textures.getResource(ImageList.class, "a_btn");
		ELEMENTS[0] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[0].setParent(this);
		ELEMENTS[0].setPosition(new Point(8, 8));
		
		images = Textures.getResource(ImageList.class, "b_btn");
		ELEMENTS[1] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[1].setParent(this);
		ELEMENTS[1].setPosition(new Point(64, 8));
		
		images = Textures.getResource(ImageList.class, "c_btn");
		ELEMENTS[2] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[2].setParent(this);
		ELEMENTS[2].setPosition(new Point(120, 8));
		
		images = Textures.getResource(ImageList.class, "d_btn");
		ELEMENTS[3] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[3].setParent(this);
		ELEMENTS[3].setPosition(new Point(176, 8));
		
		images = Textures.getResource(ImageList.class, "e_btn");
		ELEMENTS[4] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[4].setParent(this);
		ELEMENTS[4].setPosition(new Point(232, 8));
		
		images = Textures.getResource(ImageList.class, "f_btn");
		ELEMENTS[5] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[5].setParent(this);
		ELEMENTS[5].setPosition(new Point(288, 8));
		
		images = Textures.getResource(ImageList.class, "g_btn");
		ELEMENTS[6] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[6].setParent(this);
		ELEMENTS[6].setPosition(new Point(344, 8));
		
		images = Textures.getResource(ImageList.class, "h_btn");
		ELEMENTS[7] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[7].setParent(this);
		ELEMENTS[7].setPosition(new Point(400, 8));
		
		images = Textures.getResource(ImageList.class, "i_btn");
		ELEMENTS[8] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[8].setParent(this);
		ELEMENTS[8].setPosition(new Point(456, 8));
		
		images = Textures.getResource(ImageList.class, "j_btn");
		ELEMENTS[9] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[9].setParent(this);
		ELEMENTS[9].setPosition(new Point(512, 8));

		images = Textures.getResource(ImageList.class, "backSpace_btn");
		BACKSPACE_BUTTON = new ButtonElement(new Rectangle(0, 0, 104, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		BACKSPACE_BUTTON.setParent(this);
		BACKSPACE_BUTTON.setPosition(new Point(568, 8));
		BACKSPACE_BUTTON.setEnabled(false);
		// ====================================

		// SECOND ROW
		// ====================================
		images = Textures.getResource(ImageList.class, "k_btn");
		ELEMENTS[10] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[10].setParent(this);
		ELEMENTS[10].setPosition(new Point(8, 64));
		
		images = Textures.getResource(ImageList.class, "l_btn");
		ELEMENTS[11] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[11].setParent(this);
		ELEMENTS[11].setPosition(new Point(64, 64));
		
		images = Textures.getResource(ImageList.class, "m_btn");
		ELEMENTS[12] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[12].setParent(this);
		ELEMENTS[12].setPosition(new Point(120, 64));
		
		images = Textures.getResource(ImageList.class, "n_btn");
		ELEMENTS[13] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[13].setParent(this);
		ELEMENTS[13].setPosition(new Point(176, 64));
		
		images = Textures.getResource(ImageList.class, "o_btn");
		ELEMENTS[14] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[14].setParent(this);
		ELEMENTS[14].setPosition(new Point(232, 64));
		
		images = Textures.getResource(ImageList.class, "p_btn");
		ELEMENTS[15] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[15].setParent(this);
		ELEMENTS[15].setPosition(new Point(288, 64));
		
		images = Textures.getResource(ImageList.class, "q_btn");
		ELEMENTS[16] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[16].setParent(this);
		ELEMENTS[16].setPosition(new Point(344, 64));
		
		images = Textures.getResource(ImageList.class, "r_btn");
		ELEMENTS[17] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[17].setParent(this);
		ELEMENTS[17].setPosition(new Point(400, 64));
		
		images = Textures.getResource(ImageList.class, "s_btn");
		ELEMENTS[18] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[18].setParent(this);
		ELEMENTS[18].setPosition(new Point(456, 64));
		
		images = Textures.getResource(ImageList.class, "t_btn");
		ELEMENTS[19] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[19].setParent(this);
		ELEMENTS[19].setPosition(new Point(512, 64));
		
		images = Textures.getResource(ImageList.class, "return_btn");
		RETURN_BUTTON = new ButtonElement(new Rectangle(0, 0, 128, 104), images.get(0), images.get(1), images.get(2), images.get(3));
		RETURN_BUTTON.setParent(this);
		RETURN_BUTTON.setPosition(new Point(544, 64));
		RETURN_BUTTON.setEnabled(false);
		// ====================================
		
		// THIRD ROW
		// ====================================
		images = Textures.getResource(ImageList.class, "u_btn");
		ELEMENTS[20] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[20].setParent(this);
		ELEMENTS[20].setPosition(new Point(36, 120));
		
		images = Textures.getResource(ImageList.class, "v_btn");
		ELEMENTS[21] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[21].setParent(this);
		ELEMENTS[21].setPosition(new Point(92, 120));
		
		images = Textures.getResource(ImageList.class, "w_btn");
		ELEMENTS[22] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[22].setParent(this);
		ELEMENTS[22].setPosition(new Point(148, 120));
		
		images = Textures.getResource(ImageList.class, "space_btn");
		SPACE_BUTTON = new ButtonElement(new Rectangle(0, 0, 680, 176), images.get(0), images.get(1), images.get(2), images.get(3));
		SPACE_BUTTON.setParent(this);
		SPACE_BUTTON.setPosition(new Point(204, 120));
		SPACE_BUTTON.setEnabled(false);
		
		images = Textures.getResource(ImageList.class, "x_btn");
		ELEMENTS[23] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[23].setParent(this);
		ELEMENTS[23].setPosition(new Point(372, 120));
		
		images = Textures.getResource(ImageList.class, "y_btn");
		ELEMENTS[24] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[24].setParent(this);
		ELEMENTS[24].setPosition(new Point(428, 120));
		
		images = Textures.getResource(ImageList.class, "z_btn");
		ELEMENTS[25] = new ButtonElement(new Rectangle(0, 0, 48, 48), images.get(0), images.get(1), images.get(2), images.get(3));
		ELEMENTS[25].setParent(this);
		ELEMENTS[25].setPosition(new Point(484, 120));
		// ====================================
	}
	// ====================================

	// OBJECT METHODS
	// ====================================
	@Override
	public void onMousePress(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMousePress(event);
		}
		
		BACKSPACE_BUTTON.onMousePress(event);
		RETURN_BUTTON.onMousePress(event);
		SPACE_BUTTON.onMousePress(event);
		
		for(int index = 0; index < ELEMENTS.length; index++){
			if(ELEMENTS[index].isActive()){
				input.append((char) (index + 65));
			}
		}
		
		if (SPACE_BUTTON.isActive()) {
			input.append(" ");	
		}
		
		if(BACKSPACE_BUTTON.isActive()){
			input.deleteCharAt(input.length()-1);
		}
		
		if(RETURN_BUTTON.isActive()){
			value = DONE;
		} else {
			value = NOT_DONE;
		}
		
		if (input.length() > 0) {
			BACKSPACE_BUTTON.setEnabled(true);
			RETURN_BUTTON.setEnabled(true);
			SPACE_BUTTON.setEnabled(true);
		} else {
			BACKSPACE_BUTTON.setEnabled(false);
			RETURN_BUTTON.setEnabled(false);
			SPACE_BUTTON.setEnabled(false);
		}
	}

	@Override
	public void onMouseRelease(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMouseRelease(event);
		}
		
		BACKSPACE_BUTTON.onMouseRelease(event);
		RETURN_BUTTON.onMouseRelease(event);
		SPACE_BUTTON.onMouseRelease(event);
	}
	
	@Override
	public void onMouseMotion(MouseEvent event) {
		for (GUIElement element : ELEMENTS) {
			element.onMouseMotion(event);
		}
		
		BACKSPACE_BUTTON.onMouseMotion(event);
		RETURN_BUTTON.onMouseMotion(event);
		SPACE_BUTTON.onMouseMotion(event);
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	@Override
	public BufferedImage getImage() {
		BufferedImage image = ImageProcessing.createCopy(IMAGE.getSource());
		
		Graphics imageGraphics = image.getGraphics();
		
		for (int index = 0; index < ELEMENTS.length; index++) {
			imageGraphics.drawImage(ELEMENTS[index].getImage(), ELEMENTS[index].getPosition().x, ELEMENTS[index].getPosition().y, null);
		}
		
		imageGraphics.drawImage(SPACE_BUTTON.getImage(), SPACE_BUTTON.getPosition().x, SPACE_BUTTON.getPosition().y, null);
		
		imageGraphics.drawImage(BACKSPACE_BUTTON.getImage(), BACKSPACE_BUTTON.getPosition().x, BACKSPACE_BUTTON.getPosition().y, null);
		
		imageGraphics.drawImage(RETURN_BUTTON.getImage(), RETURN_BUTTON.getPosition().x, RETURN_BUTTON.getPosition().y, null);
		
		return image;
	}
	
	public int getValue() {
		return value;
	}

	public StringBuilder getInput() {
		return input;
	}
	
	public void clearInput(){
		this.input = new StringBuilder();
		BACKSPACE_BUTTON.setEnabled(false);
		RETURN_BUTTON.setEnabled(false);
		SPACE_BUTTON.setEnabled(false);
	}
	// ====================================
}
