package eu.eiting.StarCharge.visualization.menu.menuElements;

import java.awt.Rectangle;
import java.awt.event.MouseEvent;

import eu.eiting.StarCharge.model.resources.datatypes.BufferedImageProxy;

public class SwitchElement extends ButtonElement {
	// OBJECT ATTRIBUTES
	// ============================================
	private SwitchGroup group = null;
	// ============================================
	
	// CONSTRUCTOR
	// ============================================
	public SwitchElement(Rectangle dimension, BufferedImageProxy inactive, BufferedImageProxy active, BufferedImageProxy hovering, BufferedImageProxy disabled) {
		super(dimension, inactive, active, hovering, disabled);
	}
	// ============================================
	
	// OBJECT METHODS
	// ============================================
	@Override
	public void onMousePress(MouseEvent event) {
		if(contains(event.getPoint())){
			if(group == null){
				setActive(!isActive());
			} else {
				group.setActive(this);
			}
		}
	}
	
	@Override
	public void onMouseRelease(MouseEvent event) {}
	// ============================================
	
	// GETTER AND SETTER
	// ============================================
	public void setGroup(SwitchGroup group) {
		if(group != null){
			group.remove(this);
		}
		
		this.group = group;
		
		if(group != null){
			group.add(this);
		}
	}
	
	public SwitchGroup getGroup() {
		return group;
	}
	// ============================================
}
