package eu.eiting.StarCharge.visualization.menu.menuElements;

import java.util.ArrayList;

public class SwitchGroup {
	// OBJECT ATTRIBUTES
	// ============================================
	private final ArrayList<SwitchElement> ELEMENTS = new ArrayList<SwitchElement>();
	// ============================================
	
	// OBJECT METHODS
	// ============================================
	private void validate(){
		SwitchElement element = null;
		
		for (SwitchElement item : ELEMENTS) {
			if(item.isActive()){
				element = item;
			}
		}
		
		for (SwitchElement item : ELEMENTS) {
			item.setActive(false);
		}
		
		if(element != null){
			element.setActive(true);
		} else if(ELEMENTS.size() > 0){
			ELEMENTS.get(0).setActive(true);
		}
	}
	// ============================================
	
	// GETTER AND SETTER
	// ============================================
	public void setActive(SwitchElement element) {
		for (SwitchElement item : ELEMENTS) {
			item.setActive(false);
		}
		
		element.setActive(true);
	}

	public void add(SwitchElement element){
		if(!ELEMENTS.contains(element)) {
			ELEMENTS.add(element);

			validate();
		}
	}
	
	public void remove(SwitchElement element){
		ELEMENTS.remove(element);

		validate();
	}
	// ============================================
}
