package eu.eiting.StarCharge.visualization.menu.menuElements;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;

public class TextElement extends GUIElement {
	// OBJECT ATTRIBUTES
	// ====================================
	private String content	= " ";
	private Font font		= null;
	private Color color		= Color.WHITE;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public TextElement(Rectangle dimension) {
		super(dimension);
		
		this.font = new Font("Downlink", Font.PLAIN, 24);
	}
	// ====================================

	// OBJECT ATTRIBUTES
	// ====================================
	@Override
	public void onMousePress(MouseEvent event) {}
	
	@Override
	public void onMouseRelease(MouseEvent event) {}
	
	@Override
	public void onMouseMotion(MouseEvent event) {}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	public void setContent(String content){
		this.content = content;
	}
	
	public void clearContent(){
		this.content = "";
	}
	
	@Override
	public BufferedImage getImage() {
		BufferedImage product = new BufferedImage(getDimension().width, getDimension().height, BufferedImage.TYPE_INT_ARGB);
		
		Graphics imageGraphics = product.getGraphics();

		imageGraphics.setColor(new Color(75, 125, 25));
		imageGraphics.setFont(font);
		imageGraphics.drawString(content, 16, 40);
		
		return product;
	}
	
	public String getContent() {
		return content;
	}

	public void setColor(Color color) {
		this.color = color;
	}
	
	public Color getColor() {
		return color;
	}
	
	public void setFont(Font font) {
		this.font = font;
	}
	
	public Font getFont() {
		return font;
	}
	// ====================================
}
