package eu.eiting.StarCharge.visualization.menu.menuElements.solarSystem;

import java.awt.Point;
import java.awt.Rectangle;

import eu.eiting.StarCharge.model.Updateable;
import eu.eiting.StarCharge.model.resources.datatypes.BufferedImageProxy;
import eu.eiting.StarCharge.model.solarSystem.Location;
import eu.eiting.StarCharge.visualization.menu.menuElements.SwitchElement;

public class LocationElement extends SwitchElement implements Updateable {
	// OBJECT ATTRIBUTES
	// ====================================
	private final Location PARENT;
	// ====================================

	// CONSTRUCTOR
	// ====================================
	public LocationElement(Rectangle dimension, BufferedImageProxy inactive, BufferedImageProxy active, BufferedImageProxy hovering, BufferedImageProxy disabled, Location parent) {
		super(dimension, inactive, active, hovering, disabled);
		this.PARENT			= parent;
	}
	// ====================================
	
	// OBJECT METHODS
	// ====================================
	@Override
	public void update() {
		setPosition(new Point((int) (PARENT.getTransform().getPosition().x - getDimension().width / 2), (int) (PARENT.getTransform().getPosition().y - getDimension().height / 2)));
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	public Location getParent(){
		return PARENT;
	}
	// ====================================
}
