package eu.eiting.StarCharge.visualization.views;

import java.awt.Dimension;

import javax.swing.JPanel;

import eu.eiting.StarCharge.control.StarCharge;
import eu.eiting.StarCharge.control.controller.BaseController;
import eu.eiting.StarCharge.model.GameModel;
import eu.eiting.StarCharge.model.listener.ChangeListener;

public abstract class BaseView extends JPanel implements ChangeListener<GameModel> {
	// CLASS ATTRIBUTES
	// ====================================
	private static final long serialVersionUID = 8656171770375570958L;
	// ====================================

	// OBJECT ATTRIBUTES
	// ====================================
	private GameModel gameModel = null;
	// ====================================

	// CONSTRUCTOR
	// =====================================
	public BaseView(Dimension currentResolution) {
		setSize(currentResolution);

		StarCharge.addGameModelListener(this);
	}
	// =====================================

	// OBJECT METHODS
	// ====================================
	public abstract BaseController[] getController();

	@Override
	public void onChange(GameModel model) {
		gameModel = model;
	}
	// ====================================

	// GETTER AND SETTER
	// ====================================
	protected GameModel getGameModel(){
		return gameModel;
	}
	// ====================================
}
