package eu.eiting.StarCharge.visualization.views;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

import eu.eiting.StarCharge.control.controller.BaseController;
import eu.eiting.StarCharge.control.controller.MenuController;
import eu.eiting.StarCharge.visualization.menu.MainMenuGUI;
import eu.eiting.StarCharge.visualization.menu.ProfileAddMenuGUI;
import eu.eiting.StarCharge.visualization.menu.ProfileMainMenuGUI;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer;
import eu.eiting.StarCharge.visualization.menu.container.GUIContainer.Menus;
import eu.eiting.StarCharge.visualization.menu.menuElements.GUIElement;

public class MenuView extends BaseView {
	// CLASS ATTRIBUTES
	// ====================================
	private static final long serialVersionUID	= -5849321278520615282L;
	// ====================================
	
	// OBJECT ATTRIBUTES
	// ====================================
	private MenuController mc					= null;
	private GUIContainer gui					= null;
	// ====================================
	
	// CONSTRUCTOR
	// ====================================
	public MenuView(Dimension currentResolution){
		super(currentResolution);
		// set up the menus
		// ====================================
		gui = new GUIContainer();
		gui.addMenu(GUIContainer.Menus.PROFILE_MAIN_MENU,  new ProfileMainMenuGUI(gui));
		gui.addMenu(GUIContainer.Menus.PROFILE_ADD_MENU,  new ProfileAddMenuGUI(gui));
		gui.addMenu(GUIContainer.Menus.MAIN_MENU, new MainMenuGUI(gui));
		
		gui.changeMenu(Menus.PROFILE_MAIN_MENU);
		// ====================================

		mc = new MenuController(gui);

		addMouseListener(mc);
		addMouseMotionListener(mc);
	}
	// ====================================
	
	// OBJECT METHODS
	// ====================================
	@Override
	protected void paintComponent(Graphics g) {

		g.setColor(Color.BLACK);
		g.fillRect(0, 0, getWidth(), getHeight());
		
		if (gui.currentMenu.isActive()) {
			for (GUIElement me : gui.getGuiElements()) {
				g.drawImage(me.getImage(), me.getPosition().x, me.getPosition().y, null);
			}
		}
		
		g.setColor(Color.RED);
		
		if(getGameModel() != null && getGameModel().player != null){
			g.drawString(getGameModel().player.getName(), 320, 32);
		}
	}
	// ====================================
	
	// GETTER AND SETTER
	// ====================================
	@Override
	public BaseController[] getController() {
		BaseController[] controllers = {mc};
		
		return controllers;
	}
	// ====================================
}
